<?xml version="1.0" encoding="UTF-8"?>
<!--
/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */
-->
<listing xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="urn:magento:module:Magento_Ui:etc/ui_configuration.xsd">

    <argument name="data" xsi:type="array">
        <item name="js_config" xsi:type="array">
            <item name="provider" xsi:type="string">book_listing.book_listing_data_source</item>
        </item>
    </argument>

    <settings>
        <buttons>
            <button name="add">
                <url path="*/*/new"/>
                <class>primary</class>
                <label translate="true">Add New Book</label>
            </button>
        </buttons>
        <spinner>book_listing_columns</spinner>
        <deps>
            <dep>book_listing.book_listing_data_source</dep>
        </deps>
    </settings>


    <dataSource name="book_listing_data_source" component="Magento_Ui/js/grid/provider">
        <settings>
            <storageConfig>
                <param name="indexField" xsi:type="string">book_id</param>
            </storageConfig>
            <updateUrl path="mui/index/render"/>
        </settings>
        <aclResource>Academy_Book::book</aclResource>
        <dataProvider class="Magento\Framework\View\Element\UiComponent\DataProvider\DataProvider" name="book_listing_data_source">
            <settings>
                <requestFieldName>id</requestFieldName>
                <primaryFieldName>book_id</primaryFieldName>
            </settings>
        </dataProvider>
    </dataSource>


    <listingToolbar name="listing_top">
        <settings>
            <sticky>true</sticky>
        </settings>
        <bookmark name="bookmarks"/>
        <columnsControls name="columns_controls"/>
        <filterSearch name="fulltext"/>
        <filters name="listing_filters">
            <argument name="data" xsi:type="array">
                <item name="observers" xsi:type="array">
                    <item name="column" xsi:type="string">column</item>
                </item>
            </argument>
            <settings>
                <templates>
                    <filters>
                        <select>
                            <param name="template" xsi:type="string">ui/grid/filters/elements/ui-select</param>
                            <param name="component" xsi:type="string">Magento_Ui/js/form/element/ui-select</param>
                        </select>
                    </filters>
                </templates>
            </settings>
        </filters>
        <massaction name="listing_massaction">
            <action name="delete">
                <settings>
                    <confirm>
                        <message translate="true">Are you sure you want to delete selected items?</message>
                        <title translate="true">Delete items</title>
                    </confirm>
                    <url path="book/book/massDelete"/>
                    <type>delete</type>
                    <label translate="true">Delete</label>
                </settings>
            </action>
        </massaction>
        <paging name="listing_paging"/>
    </listingToolbar>



    <columns name="book_listing_columns">
        <!--<settings>-->
            <!--<editorConfig>-->
                <!--<param name="clientConfig" xsi:type="array">-->
                    <!--<item name="saveUrl" xsi:type="url" path="cms/page/inlineEdit"/>-->
                    <!--<item name="validateBeforeSave" xsi:type="boolean">false</item>-->
                <!--</param>-->
                <!--<param name="indexField" xsi:type="string">page_id</param>-->
                <!--<param name="enabled" xsi:type="boolean">true</param>-->
                <!--<param name="selectProvider" xsi:type="string">cms_page_listing.cms_page_listing.cms_page_columns.ids</param>-->
            <!--</editorConfig>-->
            <!--<childDefaults>-->
                <!--<param name="fieldAction" xsi:type="array">-->
                    <!--<item name="provider" xsi:type="string">cms_page_listing.cms_page_listing.cms_page_columns_editor</item>-->
                    <!--<item name="target" xsi:type="string">startEdit</item>-->
                    <!--<item name="params" xsi:type="array">-->
                        <!--<item name="0" xsi:type="string">${ $.$data.rowIndex }</item>-->
                        <!--<item name="1" xsi:type="boolean">true</item>-->
                    <!--</item>-->
                <!--</param>-->
            <!--</childDefaults>-->
        <!--</settings>-->
        <selectionsColumn name="ids">
            <settings>
                <indexField>book_id</indexField>
                <resizeEnabled>false</resizeEnabled>
                <resizeDefaultWidth>55</resizeDefaultWidth>
            </settings>
        </selectionsColumn>
        <column name="book_id">
            <settings>
                <filter>textRange</filter>
                <label translate="true">ID</label>
                <sorting>asc</sorting>
            </settings>
        </column>
        <column name="title">
            <settings>
                <filter>text</filter>
                <!--<editor>-->
                    <!--<validation>-->
                        <!--<rule name="required-entry" xsi:type="boolean">true</rule>-->
                    <!--</validation>-->
                    <!--<editorType>text</editorType>-->
                <!--</editor>-->
                <label translate="true">Title</label>
            </settings>
        </column>
        <column name="author">
            <settings>
                <filter>text</filter>
                <!--<editor>-->
                    <!--<validation>-->
                        <!--<rule name="validate-identifier" xsi:type="boolean">true</rule>-->
                    <!--</validation>-->
                    <!--<editorType>text</editorType>-->
                <!--</editor>-->
                <label translate="true">Author</label>
            </settings>
        </column>
        <column name="year_published">
            <settings>
                <filter>textRange</filter>
                <label translate="true">Year Published</label>
                <sorting>asc</sorting>
            </settings>
        </column>
        <column name="creation_time" class="Magento\Ui\Component\Listing\Columns\Date" component="Magento_Ui/js/grid/columns/date">
            <settings>
                <filter>dateRange</filter>
                <dataType>date</dataType>
                <label translate="true">Created</label>
            </settings>
        </column>
        <column name="update_time" class="Magento\Ui\Component\Listing\Columns\Date" component="Magento_Ui/js/grid/columns/date">
            <settings>
                <filter>dateRange</filter>
                <dataType>date</dataType>
                <label translate="true">Modified</label>
            </settings>
        </column>

        <actionsColumn name="actions" class="Academy\Book\Ui\Component\Listing\Column\BookActions">
            <settings>
                <indexField>book_id</indexField>
                <resizeEnabled>false</resizeEnabled>
                <resizeDefaultWidth>107</resizeDefaultWidth>
            </settings>
        </actionsColumn>
    </columns>
</listing>
